<template>
  <v-container :fluid="true" class="d-flex justify-center align-center fill-height">
    <div class="bg-image"></div>
    <v-row>
      <v-col cols="12">
        <div class="d-flex justify-center align-center flex-column text-center">
          <v-card
              class="pa-6 rounded" max-width="550" width="550">
            <v-img
                alt="Vetvite logo"
                class="shrink mx-auto"
                contain
                min-width="100"
                src="@/assets/images/logo/logo-blue.png"
                width="100"
            />
            <v-card-title class="text-center d-block">Rejoindre Vetvite</v-card-title>
            <v-alert id="loginError" class="d-none align-center py-2 mb-5" color="error" text></v-alert>
            <v-form ref="form" @submit.prevent="register" v-model="isValid">
              <v-select
                  hide-details
                  :items="genders"
                  :rules="[$utils.rules.required]"
                  label="Vous êtes ?"
                  dense outlined
                  v-model="user.type"
              ></v-select>
              <v-row>
                <v-col cols="12" sm="6" class="pb-0">
                  <v-text-field
                      v-model="user.lastName"
                      type="nom"
                      :rules="[$utils.rules.required, $utils.rules.text]"
                      label="Nom" required>
                  </v-text-field>
                </v-col>
                <v-col cols="12" sm="6" class="pb-0">
                  <v-text-field
                      v-model="user.firstName"
                      type="prenom"
                      :rules="[$utils.rules.required, $utils.rules.text]"
                      label="Prénom" required>
                  </v-text-field>
                </v-col>
              </v-row>

              <v-text-field
                  v-model="user.email"
                  type="email"
                  :rules="[$utils.rules.required, $utils.rules.email]"
                  label="Adresse e-mail" required>
              </v-text-field>
              <v-text-field
                  v-model="user.phoneNumber"
                  type="tel"
                  :counter="10"
                  :rules="[$utils.rules.required, $utils.rules.phoneNumber]"
                  label="Numéro de téléphone" required>
              </v-text-field>
              <v-text-field
                  v-model="user.password"
                  type="password"
                  :rules="[$utils.rules.required, $utils.rules.min, $utils.rules.password, $utils.rules.max]"
                  label="Mot de passe">
              </v-text-field>
              <v-text-field
                  v-model="user.passwordConfirmation"
                  type="password"
                  :rules="[$utils.rules.required, rules.passwordConfirmationRule]"
                  label="Confirmation du mot de passe"
              >
              </v-text-field>
              <v-checkbox
                  :rules="[$utils.rules.required]"
                  v-model="user.agree"
                  label="J'accepte les conditions générales d'utilisation"
              ></v-checkbox>
              <v-btn depressed type="submit" color="primary" class="mt-3" full-width :loading="loading"
                     :disabled="loading || !user.agree || !isValid">S'inscrire
              </v-btn>
            </v-form>
          </v-card>
          <div class="mt-2 white--text">
            <router-link :to="{name:'Login'}" class="white--text hover-underline hover-opacity">Se connecter
              sur Vetvite
            </router-link>
          </div>
        </div>
      </v-col>
    </v-row>
  </v-container>
</template>

<script>
export default {
  data() {
    return {
      genders: [
        {
          text: 'Je suis un particulier',
          value: 'client'
        },
        {
          text: 'Je suis un professionnel',
          value: 'pro'
        }
      ],
      rules: {
        passwordConfirmationRule: () => (this.user.password === this.user.passwordConfirmation) || 'Les deux mot de passe ne correspondent pas !'
      },

      user: {
        type: '',
        firstName: "",
        lastName: "",
        agree: false,
        email: "",
        phoneNumber: "",
        password: "",
        passwordConfirmation: "",
      },
      loading: false,
      isValid: false,
    }
  },
  methods: {
    register() {

      this.loading = true;

      let data = {
        email: this.user.email,
        phoneNumber: this.user.phoneNumber,
        plainPassword: this.user.password,
        firstName: this.user.firstName,
        lastName: this.user.lastName,
        type: this.user.type,
      };

      let element = document.getElementById('loginError');
      element.classList.remove('d-flex');

      this.$store.dispatch('register', data)
          .then(() => this.$router.push({name: 'ConfirmationRegistration'}))
          .catch(err => {
            console.log(err.response ? err.response : err);


            err = err.response ?
              (err.response.data ?
                (err.response.data['hydra:description'] ?
                  err.response.data['hydra:description'] :
                    (err.response.data.detail ? err.response.data.detail : err.response.data) )
              : err.response.message ? err.response.message :
              err.response)
            : err;

            if(typeof err !== 'string'){
              err = 'Connexion impossible !';
            }

            element.innerHTML = err;
            element.classList.add('d-flex');
          })
          .finally(() => {
            this.loading = false
          });
    }
  }
}
</script>
